// $ANTLR 3.5 /compiler_study/CShell/antlr/CShell.g 2013-01-11 22:18:18

package cshell.interpreter;


import org.antlr.runtime.*;
import java.util.Stack;
import java.util.List;
import java.util.ArrayList;

@SuppressWarnings("all")
public class CShellLexer extends Lexer {
	public static final int EOF=-1;
	public static final int T__42=42;
	public static final int T__43=43;
	public static final int T__44=44;
	public static final int T__45=45;
	public static final int T__46=46;
	public static final int T__47=47;
	public static final int T__48=48;
	public static final int T__49=49;
	public static final int T__50=50;
	public static final int T__51=51;
	public static final int T__52=52;
	public static final int ADD=4;
	public static final int ARGS=5;
	public static final int ARRAY=6;
	public static final int ARRAY_ELEMENT=7;
	public static final int ASSIGN=8;
	public static final int BLOCK=9;
	public static final int CALL=10;
	public static final int CHAR=11;
	public static final int DEC=12;
	public static final int DEF=13;
	public static final int DIV=14;
	public static final int ELSE=15;
	public static final int ELSEIF=16;
	public static final int EQ=17;
	public static final int FIELDS=18;
	public static final int FLOAT=19;
	public static final int FOR=20;
	public static final int FOR1=21;
	public static final int FOR2=22;
	public static final int FOR3=23;
	public static final int GT=24;
	public static final int ID=25;
	public static final int IF=26;
	public static final int INC=27;
	public static final int INT=28;
	public static final int LENGTH=29;
	public static final int LETTER=30;
	public static final int LT=31;
	public static final int MUL=32;
	public static final int NL=33;
	public static final int PREV=34;
	public static final int PRINT=35;
	public static final int RETURN=36;
	public static final int SL_COMMENT=37;
	public static final int STRING=38;
	public static final int SUB=39;
	public static final int SUFFIX=40;
	public static final int WS=41;

	// delegates
	// delegators
	public Lexer[] getDelegates() {
		return new Lexer[] {};
	}

	public CShellLexer() {} 
	public CShellLexer(CharStream input) {
		this(input, new RecognizerSharedState());
	}
	public CShellLexer(CharStream input, RecognizerSharedState state) {
		super(input,state);
	}
	@Override public String getGrammarFileName() { return "/compiler_study/CShell/antlr/CShell.g"; }

	// $ANTLR start "ADD"
	public final void mADD() throws RecognitionException {
		try {
			int _type = ADD;
			int _channel = DEFAULT_TOKEN_CHANNEL;
			// /compiler_study/CShell/antlr/CShell.g:6:5: ( '+' )
			// /compiler_study/CShell/antlr/CShell.g:6:7: '+'
			{
			match('+'); 
			}

			state.type = _type;
			state.channel = _channel;
		}
		finally {
			// do for sure before leaving
		}
	}
	// $ANTLR end "ADD"

	// $ANTLR start "ASSIGN"
	public final void mASSIGN() throws RecognitionException {
		try {
			int _type = ASSIGN;
			int _channel = DEFAULT_TOKEN_CHANNEL;
			// /compiler_study/CShell/antlr/CShell.g:7:8: ( '=' )
			// /compiler_study/CShell/antlr/CShell.g:7:10: '='
			{
			match('='); 
			}

			state.type = _type;
			state.channel = _channel;
		}
		finally {
			// do for sure before leaving
		}
	}
	// $ANTLR end "ASSIGN"

	// $ANTLR start "DEF"
	public final void mDEF() throws RecognitionException {
		try {
			int _type = DEF;
			int _channel = DEFAULT_TOKEN_CHANNEL;
			// /compiler_study/CShell/antlr/CShell.g:8:5: ( 'def' )
			// /compiler_study/CShell/antlr/CShell.g:8:7: 'def'
			{
			match("def"); 

			}

			state.type = _type;
			state.channel = _channel;
		}
		finally {
			// do for sure before leaving
		}
	}
	// $ANTLR end "DEF"

	// $ANTLR start "DIV"
	public final void mDIV() throws RecognitionException {
		try {
			int _type = DIV;
			int _channel = DEFAULT_TOKEN_CHANNEL;
			// /compiler_study/CShell/antlr/CShell.g:9:5: ( '/' )
			// /compiler_study/CShell/antlr/CShell.g:9:7: '/'
			{
			match('/'); 
			}

			state.type = _type;
			state.channel = _channel;
		}
		finally {
			// do for sure before leaving
		}
	}
	// $ANTLR end "DIV"

	// $ANTLR start "EQ"
	public final void mEQ() throws RecognitionException {
		try {
			int _type = EQ;
			int _channel = DEFAULT_TOKEN_CHANNEL;
			// /compiler_study/CShell/antlr/CShell.g:10:4: ( '==' )
			// /compiler_study/CShell/antlr/CShell.g:10:6: '=='
			{
			match("=="); 

			}

			state.type = _type;
			state.channel = _channel;
		}
		finally {
			// do for sure before leaving
		}
	}
	// $ANTLR end "EQ"

	// $ANTLR start "FOR"
	public final void mFOR() throws RecognitionException {
		try {
			int _type = FOR;
			int _channel = DEFAULT_TOKEN_CHANNEL;
			// /compiler_study/CShell/antlr/CShell.g:11:5: ( 'for' )
			// /compiler_study/CShell/antlr/CShell.g:11:7: 'for'
			{
			match("for"); 

			}

			state.type = _type;
			state.channel = _channel;
		}
		finally {
			// do for sure before leaving
		}
	}
	// $ANTLR end "FOR"

	// $ANTLR start "GT"
	public final void mGT() throws RecognitionException {
		try {
			int _type = GT;
			int _channel = DEFAULT_TOKEN_CHANNEL;
			// /compiler_study/CShell/antlr/CShell.g:12:4: ( '>' )
			// /compiler_study/CShell/antlr/CShell.g:12:6: '>'
			{
			match('>'); 
			}

			state.type = _type;
			state.channel = _channel;
		}
		finally {
			// do for sure before leaving
		}
	}
	// $ANTLR end "GT"

	// $ANTLR start "IF"
	public final void mIF() throws RecognitionException {
		try {
			int _type = IF;
			int _channel = DEFAULT_TOKEN_CHANNEL;
			// /compiler_study/CShell/antlr/CShell.g:13:4: ( 'if' )
			// /compiler_study/CShell/antlr/CShell.g:13:6: 'if'
			{
			match("if"); 

			}

			state.type = _type;
			state.channel = _channel;
		}
		finally {
			// do for sure before leaving
		}
	}
	// $ANTLR end "IF"

	// $ANTLR start "LENGTH"
	public final void mLENGTH() throws RecognitionException {
		try {
			int _type = LENGTH;
			int _channel = DEFAULT_TOKEN_CHANNEL;
			// /compiler_study/CShell/antlr/CShell.g:14:8: ( 'length' )
			// /compiler_study/CShell/antlr/CShell.g:14:10: 'length'
			{
			match("length"); 

			}

			state.type = _type;
			state.channel = _channel;
		}
		finally {
			// do for sure before leaving
		}
	}
	// $ANTLR end "LENGTH"

	// $ANTLR start "LT"
	public final void mLT() throws RecognitionException {
		try {
			int _type = LT;
			int _channel = DEFAULT_TOKEN_CHANNEL;
			// /compiler_study/CShell/antlr/CShell.g:15:4: ( '<' )
			// /compiler_study/CShell/antlr/CShell.g:15:6: '<'
			{
			match('<'); 
			}

			state.type = _type;
			state.channel = _channel;
		}
		finally {
			// do for sure before leaving
		}
	}
	// $ANTLR end "LT"

	// $ANTLR start "MUL"
	public final void mMUL() throws RecognitionException {
		try {
			int _type = MUL;
			int _channel = DEFAULT_TOKEN_CHANNEL;
			// /compiler_study/CShell/antlr/CShell.g:16:5: ( '*' )
			// /compiler_study/CShell/antlr/CShell.g:16:7: '*'
			{
			match('*'); 
			}

			state.type = _type;
			state.channel = _channel;
		}
		finally {
			// do for sure before leaving
		}
	}
	// $ANTLR end "MUL"

	// $ANTLR start "PRINT"
	public final void mPRINT() throws RecognitionException {
		try {
			int _type = PRINT;
			int _channel = DEFAULT_TOKEN_CHANNEL;
			// /compiler_study/CShell/antlr/CShell.g:17:7: ( 'print' )
			// /compiler_study/CShell/antlr/CShell.g:17:9: 'print'
			{
			match("print"); 

			}

			state.type = _type;
			state.channel = _channel;
		}
		finally {
			// do for sure before leaving
		}
	}
	// $ANTLR end "PRINT"

	// $ANTLR start "RETURN"
	public final void mRETURN() throws RecognitionException {
		try {
			int _type = RETURN;
			int _channel = DEFAULT_TOKEN_CHANNEL;
			// /compiler_study/CShell/antlr/CShell.g:18:8: ( 'return' )
			// /compiler_study/CShell/antlr/CShell.g:18:10: 'return'
			{
			match("return"); 

			}

			state.type = _type;
			state.channel = _channel;
		}
		finally {
			// do for sure before leaving
		}
	}
	// $ANTLR end "RETURN"

	// $ANTLR start "SUB"
	public final void mSUB() throws RecognitionException {
		try {
			int _type = SUB;
			int _channel = DEFAULT_TOKEN_CHANNEL;
			// /compiler_study/CShell/antlr/CShell.g:19:5: ( '-' )
			// /compiler_study/CShell/antlr/CShell.g:19:7: '-'
			{
			match('-'); 
			}

			state.type = _type;
			state.channel = _channel;
		}
		finally {
			// do for sure before leaving
		}
	}
	// $ANTLR end "SUB"

	// $ANTLR start "T__42"
	public final void mT__42() throws RecognitionException {
		try {
			int _type = T__42;
			int _channel = DEFAULT_TOKEN_CHANNEL;
			// /compiler_study/CShell/antlr/CShell.g:20:7: ( '(' )
			// /compiler_study/CShell/antlr/CShell.g:20:9: '('
			{
			match('('); 
			}

			state.type = _type;
			state.channel = _channel;
		}
		finally {
			// do for sure before leaving
		}
	}
	// $ANTLR end "T__42"

	// $ANTLR start "T__43"
	public final void mT__43() throws RecognitionException {
		try {
			int _type = T__43;
			int _channel = DEFAULT_TOKEN_CHANNEL;
			// /compiler_study/CShell/antlr/CShell.g:21:7: ( ')' )
			// /compiler_study/CShell/antlr/CShell.g:21:9: ')'
			{
			match(')'); 
			}

			state.type = _type;
			state.channel = _channel;
		}
		finally {
			// do for sure before leaving
		}
	}
	// $ANTLR end "T__43"

	// $ANTLR start "T__44"
	public final void mT__44() throws RecognitionException {
		try {
			int _type = T__44;
			int _channel = DEFAULT_TOKEN_CHANNEL;
			// /compiler_study/CShell/antlr/CShell.g:22:7: ( '++' )
			// /compiler_study/CShell/antlr/CShell.g:22:9: '++'
			{
			match("++"); 

			}

			state.type = _type;
			state.channel = _channel;
		}
		finally {
			// do for sure before leaving
		}
	}
	// $ANTLR end "T__44"

	// $ANTLR start "T__45"
	public final void mT__45() throws RecognitionException {
		try {
			int _type = T__45;
			int _channel = DEFAULT_TOKEN_CHANNEL;
			// /compiler_study/CShell/antlr/CShell.g:23:7: ( ',' )
			// /compiler_study/CShell/antlr/CShell.g:23:9: ','
			{
			match(','); 
			}

			state.type = _type;
			state.channel = _channel;
		}
		finally {
			// do for sure before leaving
		}
	}
	// $ANTLR end "T__45"

	// $ANTLR start "T__46"
	public final void mT__46() throws RecognitionException {
		try {
			int _type = T__46;
			int _channel = DEFAULT_TOKEN_CHANNEL;
			// /compiler_study/CShell/antlr/CShell.g:24:7: ( '--' )
			// /compiler_study/CShell/antlr/CShell.g:24:9: '--'
			{
			match("--"); 

			}

			state.type = _type;
			state.channel = _channel;
		}
		finally {
			// do for sure before leaving
		}
	}
	// $ANTLR end "T__46"

	// $ANTLR start "T__47"
	public final void mT__47() throws RecognitionException {
		try {
			int _type = T__47;
			int _channel = DEFAULT_TOKEN_CHANNEL;
			// /compiler_study/CShell/antlr/CShell.g:25:7: ( ';' )
			// /compiler_study/CShell/antlr/CShell.g:25:9: ';'
			{
			match(';'); 
			}

			state.type = _type;
			state.channel = _channel;
		}
		finally {
			// do for sure before leaving
		}
	}
	// $ANTLR end "T__47"

	// $ANTLR start "T__48"
	public final void mT__48() throws RecognitionException {
		try {
			int _type = T__48;
			int _channel = DEFAULT_TOKEN_CHANNEL;
			// /compiler_study/CShell/antlr/CShell.g:26:7: ( '[' )
			// /compiler_study/CShell/antlr/CShell.g:26:9: '['
			{
			match('['); 
			}

			state.type = _type;
			state.channel = _channel;
		}
		finally {
			// do for sure before leaving
		}
	}
	// $ANTLR end "T__48"

	// $ANTLR start "T__49"
	public final void mT__49() throws RecognitionException {
		try {
			int _type = T__49;
			int _channel = DEFAULT_TOKEN_CHANNEL;
			// /compiler_study/CShell/antlr/CShell.g:27:7: ( ']' )
			// /compiler_study/CShell/antlr/CShell.g:27:9: ']'
			{
			match(']'); 
			}

			state.type = _type;
			state.channel = _channel;
		}
		finally {
			// do for sure before leaving
		}
	}
	// $ANTLR end "T__49"

	// $ANTLR start "T__50"
	public final void mT__50() throws RecognitionException {
		try {
			int _type = T__50;
			int _channel = DEFAULT_TOKEN_CHANNEL;
			// /compiler_study/CShell/antlr/CShell.g:28:7: ( 'else' )
			// /compiler_study/CShell/antlr/CShell.g:28:9: 'else'
			{
			match("else"); 

			}

			state.type = _type;
			state.channel = _channel;
		}
		finally {
			// do for sure before leaving
		}
	}
	// $ANTLR end "T__50"

	// $ANTLR start "T__51"
	public final void mT__51() throws RecognitionException {
		try {
			int _type = T__51;
			int _channel = DEFAULT_TOKEN_CHANNEL;
			// /compiler_study/CShell/antlr/CShell.g:29:7: ( '{' )
			// /compiler_study/CShell/antlr/CShell.g:29:9: '{'
			{
			match('{'); 
			}

			state.type = _type;
			state.channel = _channel;
		}
		finally {
			// do for sure before leaving
		}
	}
	// $ANTLR end "T__51"

	// $ANTLR start "T__52"
	public final void mT__52() throws RecognitionException {
		try {
			int _type = T__52;
			int _channel = DEFAULT_TOKEN_CHANNEL;
			// /compiler_study/CShell/antlr/CShell.g:30:7: ( '}' )
			// /compiler_study/CShell/antlr/CShell.g:30:9: '}'
			{
			match('}'); 
			}

			state.type = _type;
			state.channel = _channel;
		}
		finally {
			// do for sure before leaving
		}
	}
	// $ANTLR end "T__52"

	// $ANTLR start "NL"
	public final void mNL() throws RecognitionException {
		try {
			int _type = NL;
			int _channel = DEFAULT_TOKEN_CHANNEL;
			// /compiler_study/CShell/antlr/CShell.g:149:4: ( ( '\\r' )? '\\n' )
			// /compiler_study/CShell/antlr/CShell.g:149:6: ( '\\r' )? '\\n'
			{
			// /compiler_study/CShell/antlr/CShell.g:149:6: ( '\\r' )?
			int alt1=2;
			int LA1_0 = input.LA(1);
			if ( (LA1_0=='\r') ) {
				alt1=1;
			}
			switch (alt1) {
				case 1 :
					// /compiler_study/CShell/antlr/CShell.g:149:6: '\\r'
					{
					match('\r'); 
					}
					break;

			}

			match('\n'); 
			}

			state.type = _type;
			state.channel = _channel;
		}
		finally {
			// do for sure before leaving
		}
	}
	// $ANTLR end "NL"

	// $ANTLR start "ID"
	public final void mID() throws RecognitionException {
		try {
			int _type = ID;
			int _channel = DEFAULT_TOKEN_CHANNEL;
			// /compiler_study/CShell/antlr/CShell.g:150:5: ( ( '$' )? ( LETTER | '_' ) ( LETTER | '0' .. '9' )* )
			// /compiler_study/CShell/antlr/CShell.g:150:9: ( '$' )? ( LETTER | '_' ) ( LETTER | '0' .. '9' )*
			{
			// /compiler_study/CShell/antlr/CShell.g:150:9: ( '$' )?
			int alt2=2;
			int LA2_0 = input.LA(1);
			if ( (LA2_0=='$') ) {
				alt2=1;
			}
			switch (alt2) {
				case 1 :
					// /compiler_study/CShell/antlr/CShell.g:150:9: '$'
					{
					match('$'); 
					}
					break;

			}

			if ( (input.LA(1) >= 'A' && input.LA(1) <= 'Z')||input.LA(1)=='_'||(input.LA(1) >= 'a' && input.LA(1) <= 'z') ) {
				input.consume();
			}
			else {
				MismatchedSetException mse = new MismatchedSetException(null,input);
				recover(mse);
				throw mse;
			}
			// /compiler_study/CShell/antlr/CShell.g:150:26: ( LETTER | '0' .. '9' )*
			loop3:
			while (true) {
				int alt3=2;
				int LA3_0 = input.LA(1);
				if ( ((LA3_0 >= '0' && LA3_0 <= '9')||(LA3_0 >= 'A' && LA3_0 <= 'Z')||(LA3_0 >= 'a' && LA3_0 <= 'z')) ) {
					alt3=1;
				}

				switch (alt3) {
				case 1 :
					// /compiler_study/CShell/antlr/CShell.g:
					{
					if ( (input.LA(1) >= '0' && input.LA(1) <= '9')||(input.LA(1) >= 'A' && input.LA(1) <= 'Z')||(input.LA(1) >= 'a' && input.LA(1) <= 'z') ) {
						input.consume();
					}
					else {
						MismatchedSetException mse = new MismatchedSetException(null,input);
						recover(mse);
						throw mse;
					}
					}
					break;

				default :
					break loop3;
				}
			}

			}

			state.type = _type;
			state.channel = _channel;
		}
		finally {
			// do for sure before leaving
		}
	}
	// $ANTLR end "ID"

	// $ANTLR start "LETTER"
	public final void mLETTER() throws RecognitionException {
		try {
			// /compiler_study/CShell/antlr/CShell.g:157:2: ( ( 'a' .. 'z' | 'A' .. 'Z' ) )
			// /compiler_study/CShell/antlr/CShell.g:
			{
			if ( (input.LA(1) >= 'A' && input.LA(1) <= 'Z')||(input.LA(1) >= 'a' && input.LA(1) <= 'z') ) {
				input.consume();
			}
			else {
				MismatchedSetException mse = new MismatchedSetException(null,input);
				recover(mse);
				throw mse;
			}
			}

		}
		finally {
			// do for sure before leaving
		}
	}
	// $ANTLR end "LETTER"

	// $ANTLR start "CHAR"
	public final void mCHAR() throws RecognitionException {
		try {
			int _type = CHAR;
			int _channel = DEFAULT_TOKEN_CHANNEL;
			// /compiler_study/CShell/antlr/CShell.g:159:5: ( '\\'' . '\\'' )
			// /compiler_study/CShell/antlr/CShell.g:159:7: '\\'' . '\\''
			{
			match('\''); 
			matchAny(); 
			match('\''); 
			}

			state.type = _type;
			state.channel = _channel;
		}
		finally {
			// do for sure before leaving
		}
	}
	// $ANTLR end "CHAR"

	// $ANTLR start "STRING"
	public final void mSTRING() throws RecognitionException {
		try {
			int _type = STRING;
			int _channel = DEFAULT_TOKEN_CHANNEL;
			// /compiler_study/CShell/antlr/CShell.g:161:7: ( '\\\"' ( . )* '\\\"' )
			// /compiler_study/CShell/antlr/CShell.g:161:9: '\\\"' ( . )* '\\\"'
			{
			match('\"'); 
			// /compiler_study/CShell/antlr/CShell.g:161:14: ( . )*
			loop4:
			while (true) {
				int alt4=2;
				int LA4_0 = input.LA(1);
				if ( (LA4_0=='\"') ) {
					alt4=2;
				}
				else if ( ((LA4_0 >= '\u0000' && LA4_0 <= '!')||(LA4_0 >= '#' && LA4_0 <= '\uFFFF')) ) {
					alt4=1;
				}

				switch (alt4) {
				case 1 :
					// /compiler_study/CShell/antlr/CShell.g:161:14: .
					{
					matchAny(); 
					}
					break;

				default :
					break loop4;
				}
			}

			match('\"'); 
			}

			state.type = _type;
			state.channel = _channel;
		}
		finally {
			// do for sure before leaving
		}
	}
	// $ANTLR end "STRING"

	// $ANTLR start "INT"
	public final void mINT() throws RecognitionException {
		try {
			int _type = INT;
			int _channel = DEFAULT_TOKEN_CHANNEL;
			// /compiler_study/CShell/antlr/CShell.g:163:5: ( ( '-' )? ( '0' .. '9' )+ )
			// /compiler_study/CShell/antlr/CShell.g:163:9: ( '-' )? ( '0' .. '9' )+
			{
			// /compiler_study/CShell/antlr/CShell.g:163:9: ( '-' )?
			int alt5=2;
			int LA5_0 = input.LA(1);
			if ( (LA5_0=='-') ) {
				alt5=1;
			}
			switch (alt5) {
				case 1 :
					// /compiler_study/CShell/antlr/CShell.g:163:9: '-'
					{
					match('-'); 
					}
					break;

			}

			// /compiler_study/CShell/antlr/CShell.g:163:13: ( '0' .. '9' )+
			int cnt6=0;
			loop6:
			while (true) {
				int alt6=2;
				int LA6_0 = input.LA(1);
				if ( ((LA6_0 >= '0' && LA6_0 <= '9')) ) {
					alt6=1;
				}

				switch (alt6) {
				case 1 :
					// /compiler_study/CShell/antlr/CShell.g:
					{
					if ( (input.LA(1) >= '0' && input.LA(1) <= '9') ) {
						input.consume();
					}
					else {
						MismatchedSetException mse = new MismatchedSetException(null,input);
						recover(mse);
						throw mse;
					}
					}
					break;

				default :
					if ( cnt6 >= 1 ) break loop6;
					EarlyExitException eee = new EarlyExitException(6, input);
					throw eee;
				}
				cnt6++;
			}

			}

			state.type = _type;
			state.channel = _channel;
		}
		finally {
			// do for sure before leaving
		}
	}
	// $ANTLR end "INT"

	// $ANTLR start "FLOAT"
	public final void mFLOAT() throws RecognitionException {
		try {
			int _type = FLOAT;
			int _channel = DEFAULT_TOKEN_CHANNEL;
			// /compiler_study/CShell/antlr/CShell.g:166:2: ( INT '.' ( INT )* | '.' ( INT )+ )
			int alt9=2;
			int LA9_0 = input.LA(1);
			if ( (LA9_0=='-'||(LA9_0 >= '0' && LA9_0 <= '9')) ) {
				alt9=1;
			}
			else if ( (LA9_0=='.') ) {
				alt9=2;
			}

			else {
				NoViableAltException nvae =
					new NoViableAltException("", 9, 0, input);
				throw nvae;
			}

			switch (alt9) {
				case 1 :
					// /compiler_study/CShell/antlr/CShell.g:166:4: INT '.' ( INT )*
					{
					mINT(); 

					match('.'); 
					// /compiler_study/CShell/antlr/CShell.g:166:12: ( INT )*
					loop7:
					while (true) {
						int alt7=2;
						int LA7_0 = input.LA(1);
						if ( (LA7_0=='-'||(LA7_0 >= '0' && LA7_0 <= '9')) ) {
							alt7=1;
						}

						switch (alt7) {
						case 1 :
							// /compiler_study/CShell/antlr/CShell.g:166:12: INT
							{
							mINT(); 

							}
							break;

						default :
							break loop7;
						}
					}

					}
					break;
				case 2 :
					// /compiler_study/CShell/antlr/CShell.g:167:4: '.' ( INT )+
					{
					match('.'); 
					// /compiler_study/CShell/antlr/CShell.g:167:8: ( INT )+
					int cnt8=0;
					loop8:
					while (true) {
						int alt8=2;
						int LA8_0 = input.LA(1);
						if ( (LA8_0=='-'||(LA8_0 >= '0' && LA8_0 <= '9')) ) {
							alt8=1;
						}

						switch (alt8) {
						case 1 :
							// /compiler_study/CShell/antlr/CShell.g:167:8: INT
							{
							mINT(); 

							}
							break;

						default :
							if ( cnt8 >= 1 ) break loop8;
							EarlyExitException eee = new EarlyExitException(8, input);
							throw eee;
						}
						cnt8++;
					}

					}
					break;

			}
			state.type = _type;
			state.channel = _channel;
		}
		finally {
			// do for sure before leaving
		}
	}
	// $ANTLR end "FLOAT"

	// $ANTLR start "WS"
	public final void mWS() throws RecognitionException {
		try {
			int _type = WS;
			int _channel = DEFAULT_TOKEN_CHANNEL;
			// /compiler_study/CShell/antlr/CShell.g:170:5: ( ( ' ' | '\\t' ) )
			// /compiler_study/CShell/antlr/CShell.g:170:9: ( ' ' | '\\t' )
			{
			if ( input.LA(1)=='\t'||input.LA(1)==' ' ) {
				input.consume();
			}
			else {
				MismatchedSetException mse = new MismatchedSetException(null,input);
				recover(mse);
				throw mse;
			}
			_channel=HIDDEN;
			}

			state.type = _type;
			state.channel = _channel;
		}
		finally {
			// do for sure before leaving
		}
	}
	// $ANTLR end "WS"

	// $ANTLR start "SL_COMMENT"
	public final void mSL_COMMENT() throws RecognitionException {
		try {
			int _type = SL_COMMENT;
			int _channel = DEFAULT_TOKEN_CHANNEL;
			// /compiler_study/CShell/antlr/CShell.g:173:5: ( '//' (~ ( '\\r' | '\\n' ) )* | '/*' ( . )* '*/' )
			int alt12=2;
			int LA12_0 = input.LA(1);
			if ( (LA12_0=='/') ) {
				int LA12_1 = input.LA(2);
				if ( (LA12_1=='/') ) {
					alt12=1;
				}
				else if ( (LA12_1=='*') ) {
					alt12=2;
				}

				else {
					int nvaeMark = input.mark();
					try {
						input.consume();
						NoViableAltException nvae =
							new NoViableAltException("", 12, 1, input);
						throw nvae;
					} finally {
						input.rewind(nvaeMark);
					}
				}

			}

			else {
				NoViableAltException nvae =
					new NoViableAltException("", 12, 0, input);
				throw nvae;
			}

			switch (alt12) {
				case 1 :
					// /compiler_study/CShell/antlr/CShell.g:173:9: '//' (~ ( '\\r' | '\\n' ) )*
					{
					match("//"); 

					// /compiler_study/CShell/antlr/CShell.g:173:14: (~ ( '\\r' | '\\n' ) )*
					loop10:
					while (true) {
						int alt10=2;
						int LA10_0 = input.LA(1);
						if ( ((LA10_0 >= '\u0000' && LA10_0 <= '\t')||(LA10_0 >= '\u000B' && LA10_0 <= '\f')||(LA10_0 >= '\u000E' && LA10_0 <= '\uFFFF')) ) {
							alt10=1;
						}

						switch (alt10) {
						case 1 :
							// /compiler_study/CShell/antlr/CShell.g:
							{
							if ( (input.LA(1) >= '\u0000' && input.LA(1) <= '\t')||(input.LA(1) >= '\u000B' && input.LA(1) <= '\f')||(input.LA(1) >= '\u000E' && input.LA(1) <= '\uFFFF') ) {
								input.consume();
							}
							else {
								MismatchedSetException mse = new MismatchedSetException(null,input);
								recover(mse);
								throw mse;
							}
							}
							break;

						default :
							break loop10;
						}
					}

					_channel=HIDDEN;
					}
					break;
				case 2 :
					// /compiler_study/CShell/antlr/CShell.g:174:8: '/*' ( . )* '*/'
					{
					match("/*"); 

					// /compiler_study/CShell/antlr/CShell.g:174:13: ( . )*
					loop11:
					while (true) {
						int alt11=2;
						int LA11_0 = input.LA(1);
						if ( (LA11_0=='*') ) {
							int LA11_1 = input.LA(2);
							if ( (LA11_1=='/') ) {
								alt11=2;
							}
							else if ( ((LA11_1 >= '\u0000' && LA11_1 <= '.')||(LA11_1 >= '0' && LA11_1 <= '\uFFFF')) ) {
								alt11=1;
							}

						}
						else if ( ((LA11_0 >= '\u0000' && LA11_0 <= ')')||(LA11_0 >= '+' && LA11_0 <= '\uFFFF')) ) {
							alt11=1;
						}

						switch (alt11) {
						case 1 :
							// /compiler_study/CShell/antlr/CShell.g:174:13: .
							{
							matchAny(); 
							}
							break;

						default :
							break loop11;
						}
					}

					match("*/"); 

					_channel=HIDDEN;
					}
					break;

			}
			state.type = _type;
			state.channel = _channel;
		}
		finally {
			// do for sure before leaving
		}
	}
	// $ANTLR end "SL_COMMENT"

	@Override
	public void mTokens() throws RecognitionException {
		// /compiler_study/CShell/antlr/CShell.g:1:8: ( ADD | ASSIGN | DEF | DIV | EQ | FOR | GT | IF | LENGTH | LT | MUL | PRINT | RETURN | SUB | T__42 | T__43 | T__44 | T__45 | T__46 | T__47 | T__48 | T__49 | T__50 | T__51 | T__52 | NL | ID | CHAR | STRING | INT | FLOAT | WS | SL_COMMENT )
		int alt13=33;
		alt13 = dfa13.predict(input);
		switch (alt13) {
			case 1 :
				// /compiler_study/CShell/antlr/CShell.g:1:10: ADD
				{
				mADD(); 

				}
				break;
			case 2 :
				// /compiler_study/CShell/antlr/CShell.g:1:14: ASSIGN
				{
				mASSIGN(); 

				}
				break;
			case 3 :
				// /compiler_study/CShell/antlr/CShell.g:1:21: DEF
				{
				mDEF(); 

				}
				break;
			case 4 :
				// /compiler_study/CShell/antlr/CShell.g:1:25: DIV
				{
				mDIV(); 

				}
				break;
			case 5 :
				// /compiler_study/CShell/antlr/CShell.g:1:29: EQ
				{
				mEQ(); 

				}
				break;
			case 6 :
				// /compiler_study/CShell/antlr/CShell.g:1:32: FOR
				{
				mFOR(); 

				}
				break;
			case 7 :
				// /compiler_study/CShell/antlr/CShell.g:1:36: GT
				{
				mGT(); 

				}
				break;
			case 8 :
				// /compiler_study/CShell/antlr/CShell.g:1:39: IF
				{
				mIF(); 

				}
				break;
			case 9 :
				// /compiler_study/CShell/antlr/CShell.g:1:42: LENGTH
				{
				mLENGTH(); 

				}
				break;
			case 10 :
				// /compiler_study/CShell/antlr/CShell.g:1:49: LT
				{
				mLT(); 

				}
				break;
			case 11 :
				// /compiler_study/CShell/antlr/CShell.g:1:52: MUL
				{
				mMUL(); 

				}
				break;
			case 12 :
				// /compiler_study/CShell/antlr/CShell.g:1:56: PRINT
				{
				mPRINT(); 

				}
				break;
			case 13 :
				// /compiler_study/CShell/antlr/CShell.g:1:62: RETURN
				{
				mRETURN(); 

				}
				break;
			case 14 :
				// /compiler_study/CShell/antlr/CShell.g:1:69: SUB
				{
				mSUB(); 

				}
				break;
			case 15 :
				// /compiler_study/CShell/antlr/CShell.g:1:73: T__42
				{
				mT__42(); 

				}
				break;
			case 16 :
				// /compiler_study/CShell/antlr/CShell.g:1:79: T__43
				{
				mT__43(); 

				}
				break;
			case 17 :
				// /compiler_study/CShell/antlr/CShell.g:1:85: T__44
				{
				mT__44(); 

				}
				break;
			case 18 :
				// /compiler_study/CShell/antlr/CShell.g:1:91: T__45
				{
				mT__45(); 

				}
				break;
			case 19 :
				// /compiler_study/CShell/antlr/CShell.g:1:97: T__46
				{
				mT__46(); 

				}
				break;
			case 20 :
				// /compiler_study/CShell/antlr/CShell.g:1:103: T__47
				{
				mT__47(); 

				}
				break;
			case 21 :
				// /compiler_study/CShell/antlr/CShell.g:1:109: T__48
				{
				mT__48(); 

				}
				break;
			case 22 :
				// /compiler_study/CShell/antlr/CShell.g:1:115: T__49
				{
				mT__49(); 

				}
				break;
			case 23 :
				// /compiler_study/CShell/antlr/CShell.g:1:121: T__50
				{
				mT__50(); 

				}
				break;
			case 24 :
				// /compiler_study/CShell/antlr/CShell.g:1:127: T__51
				{
				mT__51(); 

				}
				break;
			case 25 :
				// /compiler_study/CShell/antlr/CShell.g:1:133: T__52
				{
				mT__52(); 

				}
				break;
			case 26 :
				// /compiler_study/CShell/antlr/CShell.g:1:139: NL
				{
				mNL(); 

				}
				break;
			case 27 :
				// /compiler_study/CShell/antlr/CShell.g:1:142: ID
				{
				mID(); 

				}
				break;
			case 28 :
				// /compiler_study/CShell/antlr/CShell.g:1:145: CHAR
				{
				mCHAR(); 

				}
				break;
			case 29 :
				// /compiler_study/CShell/antlr/CShell.g:1:150: STRING
				{
				mSTRING(); 

				}
				break;
			case 30 :
				// /compiler_study/CShell/antlr/CShell.g:1:157: INT
				{
				mINT(); 

				}
				break;
			case 31 :
				// /compiler_study/CShell/antlr/CShell.g:1:161: FLOAT
				{
				mFLOAT(); 

				}
				break;
			case 32 :
				// /compiler_study/CShell/antlr/CShell.g:1:167: WS
				{
				mWS(); 

				}
				break;
			case 33 :
				// /compiler_study/CShell/antlr/CShell.g:1:170: SL_COMMENT
				{
				mSL_COMMENT(); 

				}
				break;

		}
	}


	protected DFA13 dfa13 = new DFA13(this);
	static final String DFA13_eotS =
		"\1\uffff\1\37\1\41\1\30\1\44\1\30\1\uffff\2\30\2\uffff\2\30\1\53\6\uffff"+
		"\1\30\6\uffff\1\55\6\uffff\1\30\2\uffff\1\30\1\60\3\30\2\uffff\1\30\1"+
		"\uffff\1\65\1\66\1\uffff\4\30\2\uffff\3\30\1\76\1\30\1\100\1\30\1\uffff"+
		"\1\102\1\uffff\1\103\2\uffff";
	static final String DFA13_eofS =
		"\104\uffff";
	static final String DFA13_minS =
		"\1\11\1\53\1\75\1\145\1\52\1\157\1\uffff\1\146\1\145\2\uffff\1\162\1\145"+
		"\1\55\6\uffff\1\154\6\uffff\1\56\6\uffff\1\146\2\uffff\1\162\1\60\1\156"+
		"\1\151\1\164\2\uffff\1\163\1\uffff\2\60\1\uffff\1\147\1\156\1\165\1\145"+
		"\2\uffff\2\164\1\162\1\60\1\150\1\60\1\156\1\uffff\1\60\1\uffff\1\60\2"+
		"\uffff";
	static final String DFA13_maxS =
		"\1\175\1\53\1\75\1\145\1\57\1\157\1\uffff\1\146\1\145\2\uffff\1\162\1"+
		"\145\1\71\6\uffff\1\154\6\uffff\1\71\6\uffff\1\146\2\uffff\1\162\1\172"+
		"\1\156\1\151\1\164\2\uffff\1\163\1\uffff\2\172\1\uffff\1\147\1\156\1\165"+
		"\1\145\2\uffff\2\164\1\162\1\172\1\150\1\172\1\156\1\uffff\1\172\1\uffff"+
		"\1\172\2\uffff";
	static final String DFA13_acceptS =
		"\6\uffff\1\7\2\uffff\1\12\1\13\3\uffff\1\17\1\20\1\22\1\24\1\25\1\26\1"+
		"\uffff\1\30\1\31\1\32\1\33\1\34\1\35\1\uffff\1\37\1\40\1\21\1\1\1\5\1"+
		"\2\1\uffff\1\41\1\4\5\uffff\1\23\1\16\1\uffff\1\36\2\uffff\1\10\4\uffff"+
		"\1\3\1\6\7\uffff\1\27\1\uffff\1\14\1\uffff\1\11\1\15";
	static final String DFA13_specialS =
		"\104\uffff}>";
	static final String[] DFA13_transitionS = {
			"\1\35\1\27\2\uffff\1\27\22\uffff\1\35\1\uffff\1\32\1\uffff\1\30\2\uffff"+
			"\1\31\1\16\1\17\1\12\1\1\1\20\1\15\1\34\1\4\12\33\1\uffff\1\21\1\11\1"+
			"\2\1\6\2\uffff\32\30\1\22\1\uffff\1\23\1\uffff\1\30\1\uffff\3\30\1\3"+
			"\1\24\1\5\2\30\1\7\2\30\1\10\3\30\1\13\1\30\1\14\10\30\1\25\1\uffff\1"+
			"\26",
			"\1\36",
			"\1\40",
			"\1\42",
			"\1\43\4\uffff\1\43",
			"\1\45",
			"",
			"\1\46",
			"\1\47",
			"",
			"",
			"\1\50",
			"\1\51",
			"\1\52\2\uffff\12\33",
			"",
			"",
			"",
			"",
			"",
			"",
			"\1\54",
			"",
			"",
			"",
			"",
			"",
			"",
			"\1\34\1\uffff\12\33",
			"",
			"",
			"",
			"",
			"",
			"",
			"\1\56",
			"",
			"",
			"\1\57",
			"\12\30\7\uffff\32\30\6\uffff\32\30",
			"\1\61",
			"\1\62",
			"\1\63",
			"",
			"",
			"\1\64",
			"",
			"\12\30\7\uffff\32\30\6\uffff\32\30",
			"\12\30\7\uffff\32\30\6\uffff\32\30",
			"",
			"\1\67",
			"\1\70",
			"\1\71",
			"\1\72",
			"",
			"",
			"\1\73",
			"\1\74",
			"\1\75",
			"\12\30\7\uffff\32\30\6\uffff\32\30",
			"\1\77",
			"\12\30\7\uffff\32\30\6\uffff\32\30",
			"\1\101",
			"",
			"\12\30\7\uffff\32\30\6\uffff\32\30",
			"",
			"\12\30\7\uffff\32\30\6\uffff\32\30",
			"",
			""
	};

	static final short[] DFA13_eot = DFA.unpackEncodedString(DFA13_eotS);
	static final short[] DFA13_eof = DFA.unpackEncodedString(DFA13_eofS);
	static final char[] DFA13_min = DFA.unpackEncodedStringToUnsignedChars(DFA13_minS);
	static final char[] DFA13_max = DFA.unpackEncodedStringToUnsignedChars(DFA13_maxS);
	static final short[] DFA13_accept = DFA.unpackEncodedString(DFA13_acceptS);
	static final short[] DFA13_special = DFA.unpackEncodedString(DFA13_specialS);
	static final short[][] DFA13_transition;

	static {
		int numStates = DFA13_transitionS.length;
		DFA13_transition = new short[numStates][];
		for (int i=0; i<numStates; i++) {
			DFA13_transition[i] = DFA.unpackEncodedString(DFA13_transitionS[i]);
		}
	}

	protected class DFA13 extends DFA {

		public DFA13(BaseRecognizer recognizer) {
			this.recognizer = recognizer;
			this.decisionNumber = 13;
			this.eot = DFA13_eot;
			this.eof = DFA13_eof;
			this.min = DFA13_min;
			this.max = DFA13_max;
			this.accept = DFA13_accept;
			this.special = DFA13_special;
			this.transition = DFA13_transition;
		}
		@Override
		public String getDescription() {
			return "1:1: Tokens : ( ADD | ASSIGN | DEF | DIV | EQ | FOR | GT | IF | LENGTH | LT | MUL | PRINT | RETURN | SUB | T__42 | T__43 | T__44 | T__45 | T__46 | T__47 | T__48 | T__49 | T__50 | T__51 | T__52 | NL | ID | CHAR | STRING | INT | FLOAT | WS | SL_COMMENT );";
		}
	}

}
